function __TS__ArrayEvery(arr,callbackfn)
    local i = 0
    while(i<#arr) do
        do
            if (not callbackfn(arr[i+1],i,arr)) then
                return false
            end
        end
        i = (i+1)
    end
    return true
end
function __TS__ArrayFilter(arr,callbackfn)
    local result = {}

    local i = 0
    while(i<#arr) do
        do
            if callbackfn(arr[i+1],i,arr) then
                result[#result+1] = arr[i+1]
            end
        end
        i = (i+1)
    end
    return result
end
function __TS__ArrayForEach(arr,callbackFn)
    local i = 0
    while(i<#arr) do
        do
            callbackFn(arr[i+1],i,arr)
        end
        i = (i+1)
    end
end
function __TS__ArrayIndexOf(arr,searchElement,fromIndex)
    local len = #arr

    if len==0 then
        return -1
    end
    local n = 0

    if fromIndex then
        n = fromIndex
    end
    if n>=len then
        return -1
    end
    local k = nil

    if n>=0 then
        k = n
    else
        k = (len+n)
        if k<0 then
            k = 0
        end
    end
    local i = k
    while(i<len) do
        do
            if arr[i+1]==searchElement then
                return i
            end
        end
        i = (i+1)
    end
    return -1
end
function __TS__ArrayMap(arr,callbackfn)
    local newArray = {}

    local i = 0
    while(i<#arr) do
        do
            newArray[i+1] = callbackfn(arr[i+1],i,arr)
        end
        i = (i+1)
    end
    return newArray
end
function __TS__ArrayPush(arr,...)
    local items = { ... }
    for _, item in ipairs(items) do
        do
            arr[#arr+1] = item
        end
    end
    return #arr
end
function __TS__ArraySlice(list,first,last)
    local len = #list

    local k = nil

    if first<0 then
        k = math.max(len+first,0)
    else
        k = math.min(first,len)
    end
    local relativeEnd = last

    if last==nil then
        relativeEnd = len
    end
    local final = nil

    if relativeEnd<0 then
        final = math.max(len+relativeEnd,0)
    else
        final = math.min(relativeEnd,len)
    end
    local out = {}

    local n = 0

    while k<final do
        do
            out[n+1] = list[k+1]
            k = (k+1)
            n = (n+1)
        end
    end
    return out
end
function __TS__ArraySome(arr,callbackfn)
    local i = 0
    while(i<#arr) do
        do
            if callbackfn(arr[i+1],i,arr) then
                return true
            end
        end
        i = (i+1)
    end
    return false
end
function __TS__ArraySplice(list,start,deleteCount,...)
    local items = { ... }
    local len = #list

    local actualStart = nil

    if start<0 then
        actualStart = math.max(len+start,0)
    else
        actualStart = math.min(start,len)
    end
    local itemCount = #items

    local actualDeleteCount = nil

    if (not start) then
        actualDeleteCount = 0
    else
        if (not deleteCount) then
            actualDeleteCount = (len-actualStart)
        else
            actualDeleteCount = math.min(math.max(deleteCount,0),len-actualStart)
        end
    end
    local out = {}

    local k = 0
    while(k<actualDeleteCount) do
        do
            local from = actualStart+k

            if list[from+1] then
                out[k+1] = list[from+1]
            end
        end
        k = (k+1)
    end
    if itemCount<actualDeleteCount then
        local k = actualStart
        while(k<(len-actualDeleteCount)) do
            do
                local from = k+actualDeleteCount

                local to = k+itemCount

                if list[from+1] then
                    list[to+1] = list[from+1]
                else
                    list[to+1] = nil
                end
            end
            k = (k+1)
        end
        local k = len
        while(k>((len-actualDeleteCount)+itemCount)) do
            do
                list[k-1+1] = nil
            end
            k = (k-1)
        end
    else
        if itemCount>actualDeleteCount then
            local k = len-actualDeleteCount
            while(k>actualStart) do
                do
                    local from = (k+actualDeleteCount)-1

                    local to = (k+itemCount)-1

                    if list[from+1] then
                        list[to+1] = list[from+1]
                    else
                        list[to+1] = nil
                    end
                end
                k = (k-1)
            end
        end
    end
    local j = actualStart

    for _, e in ipairs(items) do
        do
            list[j+1] = e
            j = (j+1)
        end
    end
    local k = #list-1
    while(k>=((len-actualDeleteCount)+itemCount)) do
        do
            list[k+1] = nil
        end
        k = (k-1)
    end
    return out
end
function __TS__InstanceOf(obj,classTbl)
    while obj~=nil do
        do
            if obj.__index==classTbl then
                return true
            end
            obj = obj.__base
        end
    end
    return false
end
Map = Map or {}
Map.__index = Map
function Map.new(construct, ...)
    local instance = setmetatable({}, Map)
    if construct and Map.constructor then Map.constructor(instance, ...) end
    return instance
end
function Map.constructor(self,other)
    self.items = {}
    self.size = 0
    if __TS__InstanceOf(other, Map) then
        self.size = other.size
        for _, kvp in ipairs(other:entries()) do
            do
                self.items[kvp[0+1]] = kvp[1+1]
            end
        end
    else
        if other~=nil then
            self.size = #other
            for _, kvp in ipairs(other) do
                do
                    self.items[kvp[0+1]] = kvp[1+1]
                end
            end
        end
    end
end
function Map.clear(self)
    self.items = {}
    self.size = 0
    return
end
function Map.delete(self,key)
    local contains = self:has(key)

    if contains then
        self.size = (self.size-1)
    end
    self.items[key] = nil
    return contains
end
function Map.entries(self)
    local out = {}

    for key, _ in pairs(self.items) do
        do
            out[#out+1] = {key,self.items[key]}
        end
    end
    return out
end
function Map.forEach(self,callback)
    for key, _ in pairs(self.items) do
        do
            callback(self.items[key],key,self)
        end
    end
    return
end
function Map.get(self,key)
    return self.items[key]
end
function Map.has(self,key)
    return self.items[key]~=nil
end
function Map.keys(self)
    local out = {}

    for key, _ in pairs(self.items) do
        do
            out[#out+1] = key
        end
    end
    return out
end
function Map.set(self,key,value)
    if (not self:has(key)) then
        self.size = (self.size+1)
    end
    self.items[key] = value
    return self
end
function Map.values(self)
    local out = {}

    for key, _ in pairs(self.items) do
        do
            out[#out+1] = self.items[key]
        end
    end
    return out
end
Set = Set or {}
Set.__index = Set
function Set.new(construct, ...)
    local instance = setmetatable({}, Set)
    if construct and Set.constructor then Set.constructor(instance, ...) end
    return instance
end
function Set.constructor(self,other)
    self.items = {}
    self.size = 0
    if __TS__InstanceOf(other, Set) then
        self.size = other.size
        for _, value in ipairs(other:values()) do
            do
                self.items[value] = true
            end
        end
    else
        if other~=nil then
            self.size = #other
            for _, value in ipairs(other) do
                do
                    self.items[value] = true
                end
            end
        end
    end
end
function Set.add(self,value)
    if (not self:has(value)) then
        self.size = (self.size+1)
    end
    self.items[value] = true
    return self
end
function Set.clear(self)
    self.items = {}
    self.size = 0
    return
end
function Set.delete(self,value)
    local contains = self:has(value)

    if contains then
        self.size = (self.size-1)
    end
    self.items[value] = nil
    return contains
end
function Set.entries(self)
    local out = {}

    for key, _ in pairs(self.items) do
        do
            out[#out+1] = {key,key}
        end
    end
    return out
end
function Set.forEach(self,callback)
    for key, _ in pairs(self.items) do
        do
            callback(key,key,self)
        end
    end
    return
end
function Set.has(self,value)
    return self.items[value]==true
end
function Set.keys(self)
    local out = {}

    for key, _ in pairs(self.items) do
        do
            out[#out+1] = key
        end
    end
    return out
end
function Set.values(self)
    local out = {}

    for key, _ in pairs(self.items) do
        do
            out[#out+1] = key
        end
    end
    return out
end
function __TS__StringReplace(source,searchValue,replaceValue)
    return ({ string.gsub(source,searchValue,replaceValue) })[0+1]
end
function __TS__StringSplit(source,separator,limit)
    if limit==nil then
        limit = 4294967295
    end
    if limit==0 then
        return {}
    end
    local out = {}

    local index = 0

    local count = 0

    if (separator==nil) or (separator=="") then
        while (index<(#source-1)) and (count<limit) do
            do
                out[count+1] = string.sub(source,index+1,index+1)
                count = (count+1)
                index = (index+1)
            end
        end
    else
        local separatorLength = #separator

        local nextIndex = (string.find(source,separator,1,true) or 0)-1

        while (nextIndex>=0) and (count<limit) do
            do
                out[count+1] = string.sub(source,index+1,nextIndex)
                count = (count+1)
                index = (nextIndex+separatorLength)
                nextIndex = (string.find(source,separator,index+1,true) or 0)-1
            end
        end
    end
    if count<limit then
        out[count+1] = string.sub(source,index+1)
    end
    return out
end
function __TS__Ternary(condition,cb1,cb2)
    if condition then
        return cb1()
    else
        return cb2()
    end
end
