"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Transpiler_1 = require("../Transpiler");
const Transpiler_52_1 = require("./Transpiler.52");
const ts = require("typescript");
class LuaTranspiler53 extends Transpiler_52_1.LuaTranspiler52 {
    /** @override */
    transpileUnaryBitOperation(node, operand) {
        switch (node.operator) {
            case ts.SyntaxKind.TildeToken:
                return `~${operand}`;
        }
    }
    /** @override */
    transpileBitOperation(node, lhs, rhs) {
        switch (node.operatorToken.kind) {
            case ts.SyntaxKind.AmpersandToken:
                return `${lhs} & ${rhs}`;
            case ts.SyntaxKind.BarToken:
                return `${lhs} | ${rhs}`;
            case ts.SyntaxKind.CaretToken:
                return `${lhs} ~ ${rhs}`;
            case ts.SyntaxKind.LessThanLessThanToken:
                return `${lhs} << ${rhs}`;
            case ts.SyntaxKind.GreaterThanGreaterThanToken:
                return `${lhs} >> ${rhs}`;
            case ts.SyntaxKind.GreaterThanGreaterThanGreaterThanToken:
                throw new Transpiler_1.TranspileError("Bitwise operator >>> not supported in Lua 5.3", node);
        }
    }
    /** @override */
    getValidStringProperties() {
        return {
            fromCharCode: "string.char",
            fromCodePoint: "utf8.char",
        };
    }
}
exports.LuaTranspiler53 = LuaTranspiler53;
//# sourceMappingURL=Transpiler.53.js.map