"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Transpiler_52_1 = require("./Transpiler.52");
const ts = require("typescript");
class LuaTranspilerJIT extends Transpiler_52_1.LuaTranspiler52 {
    /** @override */
    transpileUnaryBitOperation(node, operand) {
        switch (node.operator) {
            case ts.SyntaxKind.TildeToken:
                return `bit.bnot(${operand})`;
        }
    }
    /** @override */
    transpileBitOperation(node, lhs, rhs) {
        switch (node.operatorToken.kind) {
            case ts.SyntaxKind.AmpersandToken:
                return `bit.band(${lhs},${rhs})`;
            case ts.SyntaxKind.BarToken:
                return `bit.bor(${lhs},${rhs})`;
            case ts.SyntaxKind.CaretToken:
                return `bit.bxor(${lhs},${rhs})`;
            case ts.SyntaxKind.LessThanLessThanToken:
                return `bit.lshift(${lhs},${rhs})`;
            case ts.SyntaxKind.GreaterThanGreaterThanToken:
                return `bit.rshift(${lhs},${rhs})`;
            case ts.SyntaxKind.GreaterThanGreaterThanGreaterThanToken:
                return `bit.arshift(${lhs},${rhs})`;
        }
    }
}
exports.LuaTranspilerJIT = LuaTranspilerJIT;
//# sourceMappingURL=Transpiler.JIT.js.map